"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseResultType = void 0;
const object_js_1 = require("../polyfills/object.js");
const recurse = (value) => {
    if (typeof value === 'undefined' ||
        typeof value === 'function' ||
        typeof value === 'bigint' ||
        typeof value === 'symbol' ||
        value instanceof RegExp)
        return String(value);
    if (Array.isArray(value))
        return value.map(recurse);
    if (value instanceof Set)
        return Array.from(value).map(recurse);
    if (value instanceof Map)
        return recurse((0, object_js_1.fromEntries)(value));
    if (value !== null && typeof value === 'object')
        return (0, object_js_1.fromEntries)((0, object_js_1.entries)(value).map(([key, val]) => [key, recurse(val)]));
    return value;
};
const parseResultType = (type) => {
    const result = recurse(type);
    return typeof result === 'string' ? result : JSON.stringify(result, null, 2);
};
exports.parseResultType = parseResultType;
