"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toDynamicCase = void 0;
const regex = /-/g;
const toDynamicCase = (str) => {
    if (str[1] !== '-')
        return str; 
    const [flag, ...args] = str.slice(2).split('=');
    const dynamicCase = flag.toLowerCase().replace(regex, '');
    const formattedArg = args.length > 0 ? `=${args.join('=')}` : '';
    return `--${dynamicCase}${formattedArg}`;
};
exports.toDynamicCase = toDynamicCase;
